# -*- coding: utf-8 -*-

import es, gamethread
from usermsg import hudhint
from cfglib import AddonCFG

config = AddonCFG(es.getAddonPath('sprint') + '/sprint_config.cfg')

config.text('**********************************')
config.text("* BackRaw's Sprint Configuration *")
config.text('**********************************')
sprint_time = config.cvar('sprint_time', 10, 'Set the sprinting-time.')
config.text('')
config.text('**********************************')
config.text("* BackRaw's Sprint Configuration *")
config.text('**********************************')

config.write()

player = {}

class Sprint(object):
    def __init__(self, userid):
        self.userid = userid
        self.sprint = sprint_time
    def do_sprint(self):
        if self.sprint == sprint_time:
            es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', 1.2)
            self.do()
        else:
            es.tell(self.userid, '#multi', "#green[#lightgreenSprint#green] #defaultCan't use Sprint, it's not fully reloaded!")
    def do(self):
        if self.sprint > 1:
            hudhint(self.userid, 'Sprint: ' + '|' * int(self.sprint -1))
            self.sprint -= 1
            gamethread.delayedname(1, 'minus', self.do)
        elif self.sprint == 1:
            self.sprint = 0
            es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', 1.0)
            hudhint(self.userid, 'Sprint has ended!')
            gamethread.delayed(1, hudhint, (self.userid, 'Reloading Sprint...'))
            gamethread.delayed(2, self.rel)
    def rel(self):
        if self.sprint < sprint_time:
            hudhint(self.userid, 'Sprint: ' + '|' * int(self.sprint + 1))
            self.sprint += 1
            gamethread.delayedname(2, 'plus', self.rel)
        elif self.sprint == sprint_time:
            gamethread.delayed(.2, hudhint, (self.userid, 'Sprint successfully reloaded!'))

def load():
    config.execute()
    if not es.exists('saycommand', '!sprint'):
        es.regsaycmd('!sprint', 'sprint/getsprint')
    for userid in es.getUseridList():
        player[userid] = Sprint(userid)

def unload():
    cancel_delays()
    player.clear()
    es.unregsaycmd('!sprint')

def cancel_delays():
    gamethread.cancelDelayed('plus')
    gamethread.cancelDelayed('minus')

def player_activate(ev):
    userid = int(ev['userid'])
    player[userid] = Sprint(userid)

def player_disconnect(ev):
    del player[int(ev['userid'])]

def getsprint():
    userid = int(es.getcmduserid())
    if player.has_key(userid):
        player[userid].do_sprint()

def round_start(ev):
    es.msg('#multi', '#green[#lightgreenSprint#green] #defaultSay #lightgreen!sprint #defaultto get a Sprint-Boost.')
    es.msg('#multi', '#defaultYou can also bind a key to #lightgreen!sprint #defaultand easily press it.')

def player_spawn(ev):
    cancel_delays()
    userid = int(ev['userid'])
    player[userid] = Sprint(userid)
    es.setplayerprop(userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', 1.0)
